VERSION 5.00
Object = "{102225D5-EA25-11D3-886E-00105A154A4D}#1.0#0"; "VPortal2.dll"
Begin VB.Form frmVerify 
   Caption         =   "Verify Camera Settings"
   ClientHeight    =   3615
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7335
   LinkTopic       =   "Form1"
   ScaleHeight     =   241
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   489
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox Picture1 
      Height          =   1800
      Left            =   0
      ScaleHeight     =   116
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   156
      TabIndex        =   2
      Top             =   0
      Width           =   2400
   End
   Begin VB.CommandButton cmdTest 
      Caption         =   "Test Camera"
      Height          =   495
      Left            =   360
      TabIndex        =   1
      Top             =   2160
      Width           =   1575
   End
   Begin VPORTAL2LibCtl.VideoPortal QuickCam 
      Height          =   2220
      Left            =   2520
      OleObjectBlob   =   "frmVerify_Cam.frx":0000
      TabIndex        =   0
      Top             =   0
      Width           =   2520
   End
End
Attribute VB_Name = "frmVerify"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************************************
'Program: Verify_Cam
'Purpose: To test the USB link between the camera and the computer.  The camera
'         software also needs to be installed and properly working in order for
'         the test to work.  When the test properly works, the image from the live
'         preview is captured and displayed in the picture box.
'
'
'
'
'************************************************************************************
Option Explicit 'This forces the program to have all variables declared.


Private Declare Function GetAddress Lib "converts.dll" ( _
            ByRef data As Byte) As Long
'************************************************************************************
'Purpose: This function takes a variable and returns it's address.
'         Basically, it is the C++ '&' (adress) command
'************************************************************************************






Private Sub GetPic()
'************************************************************************************
'Purpose: This function does all of the work to get the picture.  It communicates
'         with the camera to get the picture
'
'
'
'************************************************************************************

    Picture1.Cls 'Clears the smaller picture window prior to display
    
    Dim data() As Byte 'This stores the image in an array.
                            'For Example:
                            'Width of picture: 160
                            'Height of picture: 120
                            'Since it's in RGB color, 3 Bytes are needed per pixel
                            '160 * 120 * 3 = 57600 bytes for image data
                            '55 bytes needed for header information
                            'Needs to be 57655 bytes
                            
    Dim Ret_Value As Long   'Returns a 1 or 0, depending on functions success
    Dim Pic_Size As Long    'This returns the size of the picture in bytes
    Dim i As Long           'Simple for loop runner to go through the pic's bytes
    Dim Pic_Address As Long 'This is the address of the first element of the data
    Dim RGB_Offset As Long  'This is the number of bytes used for the header.
                            'Needed to get to the actual BMP data.
    Dim x As Long           'The x coordinate of the images
    Dim y As Long           'The y coordinate of the image
        
    x = 0                   'Start off at x = 0
    y = 120                 'BMP files are stored upside-down, so reading must begin
                            'from the bottom.
    
    RGB_Offset = 54         'There are 55 bytes needed for the header information.
                            'This is a constant for our images.  Less header is needed
                            'for a 24-bit image since the color information does not
                            'need to be saved.

    
    '2 calls need to be made to the picture to memory function.  The first call
    'gets the amount of space needed to store the BMP data.  For the camera we used
    '(Logitech QuickCam Pro 3000), there are 3 sizes of images, each requiring a
    'different amount of space.
    Ret_Value = QuickCam.PictureToMemory(0, 24, 0, Pic_Size, "")
    
    'This statement is needed to setup the data array based on the Pic_Size
    ReDim data(Pic_Size)
    
    'This statement gets the address of the first element of the data array
    Pic_Address = GetAddress(data(0))
    
    'The 0 and the 24 are required by the Logitech driver.
    'Pic_Adress and Pic_Size are where to store and how much to store
    'the "" value allows for a text overlay.  I do not use it.
    Ret_Value = QuickCam.PictureToMemory(0, 24, Pic_Address, Pic_Size, "")
    
    'The following for loop goes through the entire data array by 3's (RGB) to display
    'the image.  It needs to get through the offset first, but then loops through the
    'rest.
    For i = 1 To (Pic_Size - 54) / 3
    
        'This is a very slow function that sets each pixel on the screen.  While it is
        'slow, it is fast enough for the testing program.  The data is stored GRB
        Picture1.PSet (x, y), RGB(data(RGB_Offset - 1), data(RGB_Offset - 2), data(RGB_Offset))
        
        'Add 3 to get the next pixel
        RGB_Offset = RGB_Offset + 3
        
        'If we are at the end of the line, start again, otherwise, go to the next pixel.
        If (i Mod (160)) = 0 Then
           x = 0
           y = y - 1
        Else
           x = x + 1
        End If
    Next i
    
End Sub

Private Sub cmdTest_Click()
'************************************************************************************
'Purpose: This function gets called as soon as the button is clicked.
'************************************************************************************
    Call GetPic
End Sub

Private Sub Form_Load()
'************************************************************************************
'Purpose: This function is called everytime the form is loaded.  It performs all of
'         setup nessecary to get the camera operational.
'
'
'************************************************************************************

    Dim Ret_Value As Long 'Contains a 0 or 1 depending on functions success
    
    'These setup a registry entry to hold the setup information for the camera.
    'It can be set to your preference, but needs to be set in order for the
    'camera to properly function.
    QuickCam.PrepareControl "SNC_COMPSCI", "HKEY_LOCAL_MACHINE\Software\SNC_COMPSCI\CAM_COMPSCI", 0
    QuickCam.PrepareControl "", "HKEY_CURRENT_USER\Software\Logitech\Sample1", 0
    
    'Checks to ensure the camera succesfully connects through the USB port.
    'If it did not, it displays a message, then exits the program.
    If QuickCam.ConnectCamera2() = 0 Then
        MsgBox "Unable to connect to any QuickCam camera"
        Exit Sub
    End If
    
    QuickCam.EnablePreview = 1  'Enables the preview in the control
    QuickCam.Visible = 1        'Makes the control visible
    QuickCam.EnableUIElements 3, 0, 0 'Disables a status bar on the video preview
    QuickCam.EnableUIElements 4, 0, 0 'Disables more of the setup controls
    QuickCam.SetVideoFormat 160, 120, 24, 0 'Sets the video size to be 160x120
                                            'at 24-bit color
    
    Ret_Value = QuickCam.SetCameraPropertyLong(22, 0) 'Turns off the auto-white balance
    Ret_Value = QuickCam.SetCameraPropertyLong(24, 0) 'Turns off the auto-gain feature
    Ret_Value = QuickCam.SetCameraPropertyLong(16, 0) 'Turns off the PicSmart(c) feature
End Sub

